require 'cocoapods-hbh/helpers/git_depend'

module Pod
  class Command
    class Hbh < Command
      class Install < Hbh
        include Pod

        self.summary = 'pod install 拦截器，DSL加载到原始Podfile文件中。'

        self.description = <<-DESC
          pod install 拦截器
          会通过DSL加载到原始Podfile文件中
          支持 pod 'xxx' 各种写法
          支持 post_install/pre_install钩子，采用覆盖做法
        DESC
        def self.options
          [
            ['--repo-update', 'Force running `pod repo update` before install'],
            ['--deployment', 'Disallow any changes to the Podfile or the Podfile.lock during installation'],
            ['--clean-install', 'Ignore the contents of the project cache and force a full pod installation. This only ' \
          'applies to projects that have enabled incremental installation']
          ].concat(super).reject { |(name, _)| name == '--no-repo-update' }
        end

        def initialize(argv)
          @update = argv.flag?('update')
          super
          @additional_args = argv.remainder!
        end

        def run
          super.run
        end
      end
    end
  end
end
